//+-----------------------------------------------------------------------------
//  MS Bookmaker
//  Copyright (c) 1998-2000  Microsoft Corporation.  All Rights Reserved.
//
//  File:       LITConvertDemo.h
//
//  Contents:   declarations of global symbols in LITConvertDemo
//
//------------------------------------------------------------------------------
#include <windows.h>
#include <stdio.h>
#include <assert.h>
#include <comdef.h>
#include "litgen.h"

_COM_SMARTPTR_TYPEDEF(ILITCallback, __uuidof(ILITCallback));
_COM_SMARTPTR_TYPEDEF(ILITWriter, __uuidof(ILITWriter));
_COM_SMARTPTR_TYPEDEF(ILITParserHost, __uuidof(ILITParserHost));
_COM_SMARTPTR_TYPEDEF(ILITCSSHost, __uuidof(ILITCSSHost));
_COM_SMARTPTR_TYPEDEF(ILITImageHost, __uuidof(ILITImageHost));
_COM_SMARTPTR_TYPEDEF(ILITTag, __uuidof(ILITTag));

void CheckHR(HRESULT hr, const char* pszMsg, const wchar_t* pwszExtra = 0);
void ParseXML(const wchar_t* pwszURL, ILITParserHost* pHost);
void CopyCSS(const _bstr_t& bstrFilename, ILITCSSHost* pHost);
void CopyImage(const _bstr_t& bstrFilename, ILITImageHost* pHost);

class ErrHandler : public ILITCallback
{
public:
    ErrHandler() : m_lRef(0) {}
    STDMETHOD(QueryInterface)(REFIID riid, void** ppv);
    STDMETHOD_(ULONG, AddRef)();
    STDMETHOD_(ULONG, Release)();
    STDMETHOD(Message)(int iType, int iMessageCode, const wchar_t* pwszText);
private:
    long m_lRef;
};
